<?php

namespace InPost\Shipping;

use InPost\Shipping\Configuration\ShopConfiguration;
use InPost\Shipping\Install\Hooks;

class HookUpdater
{
    protected $configuration;
    protected $hookInstaller;

    public function __construct(
        ShopConfiguration $configuration,
        Hooks $hookInstaller
    ) {
        $this->configuration = $configuration;
        $this->hookInstaller = $hookInstaller;
    }

    public function updateHookRegistrations()
    {
        // register new hooks after PS version upgrade
        if (version_compare(_PS_VERSION_, $this->configuration->getPrestashopVersion(), '>')) {
            $this->hookInstaller->uninstallOutdated();

            return $this->hookInstaller->install()
                && $this->configuration->updatePrestashopVersion();
        }

        return true;
    }
}
